<?php
namespace tests\Zeedhi\Framework\DBAL\Driver\OCI8;

use Zeedhi\Framework\DBAL\Driver\OCI8\Driver;

class DriverTest extends \PHPUnit_Framework_TestCase {

    /** @var Driver */
    protected $driver;

    protected function setUp() {
        $this->driver = new Driver();
    }

    public function testConnect() {
        $this->markTestSkipped("server 55 died");
        $this->assertEquals('zeedhi_oci8', $this->driver->getName());
        $connection = $this->driver->connect(array(
            'user'      => 'ZEEDHI_DEMO',
            'password'  => 'teknisa',
            'host'      => '192.168.122.55',
            'dbname'    => 'xe'
        ), 'ZEEDHI_DEMO', 'teknisa');

        $this->assertInstanceOf('Zeedhi\Framework\DBAL\Driver\OCI8\OCI8Connection', $connection);
        $this->assertEquals(1, $connection->prepare('SELECT SYSDATE FROM DUAL')->execute());
    }

    public function testConnectException() {
        $this->markTestSkipped("server 55 died");
        $this->setExpectedException('\Doctrine\DBAL\DBALException', 'An exception occured in driver: ORA-01017');
        $connection = $this->driver->connect(array(
            'user'      => 'ZEEDHI_DEMO',
            'password'  => 'wrong_password',
            'host'      => '192.168.122.55',
            'dbname'    => 'xe'
        ), 'ZEEDHI_DEMO', 'wrong_password');
    }

}